;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                                        ;
; JonOS [Genesis] 0.0.1                                                                  ;
;  Made by GigaWolf (GigaWolf@Hotmail.com)                                               ;
;   Released under the GNU General Public License, Version 2                             ;
;                                                                                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

bits 16
[ORG 0x10000]

;----- Regdump --------------------------------------------------------------------------
;Status -- display register status
;========================================================================================
;Input: None
;Output: Register dump to OutStream
;Registers destroyed: cs, ss, sp, bp
;========================================================================================
tmpIP	dw 0
tmpSP	dw 0
tmpBP	dw 0

tmpAX	dw 0
tmpBX	dw 0
tmpCX	dw 0
tmpDX	dw 0

tmpCS	dw 0
tmpDS	dw 0
tmpES	dw 0
tmpFS	dw 0
tmpGS	dw 0
tmpSS	dw 0

tmpSI	dw 0
tmpDI	dw 0

msgStatusAX	db " AX=",0
msgStatusBX	db " BX=",0
msgStatusCX	db " CX=",0
msgStatusDX	db " DX=",0

msgStatusCS	db " CS=",0
msgStatusDS	db " DS=",0
msgStatusES	db " ES=",0
msgStatusFS	db " FS=",0
msgStatusGS	db " GS=",0
msgStatusSS	db " SS=",0

msgStatusSP	db " SP=",0
msgStatusBP	db " BP=",0
msgStatusSI	db " SI=",0
msgStatusDI	db " DI=",0
msgStatusIP	db " IP=",0

cmd1:	pop word [tmpIP]	;ret addr
	mov [tmpSP], sp
	mov [tmpBP], bp
	mov [tmpAX], ax
	mov [tmpBX], bx
	mov [tmpCX], cx
	mov [tmpDX], dx
	mov [tmpCS], cs
	mov [tmpDS], ds
	mov [tmpES], es
	mov [tmpFS], fs
	mov [tmpGS], gs
	mov [tmpSS], ss
	mov [tmpSI], si
	mov [tmpDI], di
	mov bx, 0x10
	mov si, msgRegDump
	call put_string
	mov si, msgStatusAX
	call put_string
	mov ax, [tmpAX]
	call convert
	mov si, msgStatusBX
	call put_string
	mov ax, [tmpBX]
	call convert
	mov si, msgStatusCX
	call put_string
	mov ax, [tmpCX]
	call convert
	mov si, msgStatusDX
	call put_string
	mov ax, [tmpDX]
	call convert
	mov si, newLine
	call put_string
	mov si, msgStatusCS
	call put_string
	mov ax, [tmpCS]
	call convert
	mov si, msgStatusDS
	call put_string
	mov ax, [tmpDS]
	call convert
	mov si, msgStatusES
	call put_string
	mov ax, [tmpES]
	call convert
	mov si, msgStatusFS
	call put_string
	mov ax, [tmpFS]
	call convert
	mov si, msgStatusGS
	call put_string
	mov ax, [tmpGS]
	call convert
	mov si, msgStatusSS
	call put_string
	mov ax, [tmpSS]
	call convert
	mov si, newLine
	call put_string
	mov si, msgStatusSP
	call put_string
	mov ax, [tmpSP]
	call convert
	mov si, msgStatusBP
	call put_string
	mov ax, [tmpBP]
	call convert
	mov si, msgStatusSI
	call put_string
	mov ax, [tmpSI]
	call convert
	mov si, msgStatusDI
	call put_string
	mov ax, [tmpDI]
	call convert
	mov si, msgStatusIP
	call put_string
	mov ax, [tmpIP]
	call convert
	mov si, newLine
	call put_string
	mov ax, [tmpAX]
	mov bx, [tmpBX]
	mov cx, [tmpCX]
	mov dx, [tmpDX]
	mov ds, [tmpDS]
	mov es, [tmpES]
	mov fs, [tmpFS]
	mov gs, [tmpGS]
	mov si, [tmpSI]
	mov di, [tmpDI]
	push word [tmpIP]
	ret

msgRegDump	db 13,10,13,10
		db " CPU Register Dump",13,10,
		db " -----------------",13,10,0
;----------------------------------------------------------------------------------------


;------ Time ----------------------------------------------------------------------------
;What The F*ck!? I testrun this os in a pc emulator called vmware - I'm sure you've heard
;of it... Here are the oddities: BIOS int 0x1A, function 2 should
;report BCD coded hour of day in CH, minute of hour in CL and seconds of minute in DH.
;But in vmware they are not reported correctly!
;for ex:
;Real hour:		00  01  02  03  04  05  06  07  08  09  10  11  12 ...
;Reported hour:		15  16  17  18  19  20  21  22  23  00  01  02  03 ...
;
;Real minute:		00  01  02  03  04  05  ..  50  51  52  53  54  55 ...
;Reported minute:	06  07  08  09  10  11  ..  56  57  58  59  00  01 ...
;
;It took me some time to debug, and in the end it turned out to be bug free
;in the first place >=I

;ch = hours, cl = minutes in BCD
;dh = seconds in bcd and "dl=1 if daylight savings time option" (what's that?)
;----------------------------------------------------------------------------------------
cmd2:	pusha
	mov ah, 2
	int 0x1a

	jc timeError
	mov si, msgTime
	call put_string

	mov al, ch
	mov bx, 0x10
	call convert
	mov al, ":"
	call put_char
	mov al, cl
	mov bx, 0x10
	call convert
	mov al, " "
	call put_char
	mov al, dh
	mov bx, 0x10
	call convert
	popa
	ret
timeError:
	mov si, msgTimeError
	call put_string
	popa
	ret

msgTime		db 13,10,"Time is: ",0
msgTimeError	db 13,10,"Error reading time - RTC malfunctioning!",13,10,0


; === Here is the code that makes it report somewhat correct values in vmware
; === VMware should fix this bug..

;correct for hour and print it
	mov bx, 0xa
	mov al, ch
	shr al, 4
	mul bx
	mov bl, al
	mov al, ch
	and al, 0x0F
	add al, bl
	cmp al, 15
	jb reported_hour_below_15
	sub al, 15
	jmp show_hour
reported_hour_below_15
	add al, 9
show_hour:
	mov bx, 0xa
	call convert

	mov al, ":"
	call put_char

;correct for minute and print it
	mov bx, 0xa
	mov al, cl
	shr al, 4
	mul bx
	mov bl, al
	mov al, cl
	and al, 0x0F
	add al, bl
	cmp al, 6
	jb reported_minute_below_6
	sub al, 6
	jmp show_minute
reported_minute_below_6
	add al, 54
show_minute
	mov bx, 0xa
	call convert

	mov al, " "
	mov bl, 4
	call put_color_char

;show seconds without correction
;it runs 4 seconds ahead if im correct

	mov ah, 2
	int 0x1a
	xor ah, ah
	mov al, dh
	mov bx, 0x10
	call convert
;----------------------------------------------------------------------------------------


cmd3:	jmp cmd4
	ret


;-------- Version -----------------------------------------------------------------------
cmd4:	pusha
	mov si, msgVersion
	call put_string
	popa
	ret

msgVersion	db 13,10,
		db "GNU JonOS v0.0.1 [Genesis]",13,10,
		db "Copyright(C) 2003 (GigaWolf@Hotmail.com)",13,10,
		db "This is my attempt to learn computers by writing a very basic",13,10,
		db "realmode operating system.",13,10,
		db "USE AT YOUR OWN RISK!!",13,10,0
		
;----------------------------------------------------------------------------------------


;------ Help ----------------------------------------------------------------------------
cmd5:	pusha
	mov si, msgHelp
	call put_string
	popa
	ret

msgHelp	db 13,10,13,10,
	db "Available commands are:",13,10,
	db "-----------------------",13,10,
	db "help / ?          This command",13,10,
	db "version / ver     Displays JonOS version and author",13,10,
	db "regdump           Dumps content of CPU registers",13,10,
	db "time              Displays time",13,10,
	db "set color         Change color of text/numbers",13,10,
	db "set video         Change video mode (resolution etc)",13,10,
	db "com1 status       Display COM1 status",13,10,
	db "comchat           Chat with other machine using serial calbe",13,10,
	db "restart           Restarts JonOS",13,10,
	db "reboot            Reboots computer",13,10,
	db "cls               CLear Screen",13,10,0

cmd6:	jmp cmd5
;----------------------------------------------------------------------------------------



;----- Restart --------------------------------------------------------------------------
cmd7:	pusha

	mov si, msgRestarting
	call put_string

	push word 0x10	;times to retry

transfer_kernel:
	mov dl, 0x0	;drive = 0 - floppy
	mov ax, 0x0	;reset disk system
	int 0x13	;do it several times to avoid a certain bug that
	xor ax, ax	;makes the computer hang if it fails to read the diskette
	int 0x13	;the first time.. i think it hangs because we ask for data
	xor ax, ax	;before the drive is completely reset.. this should fix it!
	int 0x13
	xor ax, ax
	int 0x13
	xor ax, ax
	int 0x13
	xor ax, ax
	int 0x13
	jc transfer_kernel
	mov bx, 0x1000
	mov es, bx
	xor bx, bx	;offset 0 of segment CODE_SEG
	mov ah, 0x2	;read sector function
	mov al, 0xF	;# of sectors to transfer
	mov ch, 0x0	;cylinder
	mov cl, 0x2	;start from sector 2
	mov dh, 0x0	;head
	mov dl, 0x0	;drive 0 - floppy
	int 0x13
	jc ReadingError
	jmp TransferOk

ReadingError:
	pop cx
	dec cx
	cmp cx, 0
	je restart_failed
	push cx
	mov si, msgReadError
	call put_string
	jmp transfer_kernel

restart_failed:
	mov si, msgRestartFailed
	call put_string
	popa
	ret


TransferOk:
	cli			;just in case
	push word 0x1000	;jump to the kernel..
	push word 0x0000
	retf

msgRestarting		db 13,10,"System restart initiated!",13,10,0
msgReadError		db "Error reading floppy disk, retrying...",13,10,0	
msgRestartFailed	db 13,10,"Can't read floppy disk!",13,10,0

;----------------------------------------------------------------------------------------



;----- Reboot ---------------------------------------------------------------------------
cmd8:	mov bx, 0x40
	mov ds, bx
	mov bx, 0x72
	mov ax, 0x1234
	mov [bx], ax
	mov al, 0xfe
	mov dx, 0x64
	out dx, al
;----------------------------------------------------------------------------------------



;-------- com1 status ---------------------------------------------------------------------
cmd9:	pusha
	call Print_COM1_Status
	popa
	ret
;----------------------------------------------------------------------------------------


cmd10:	pusha
	mov ax, 0xb800
	mov es, ax
	xor bx, bx
	mov ax, 0x6520
	mov [es:bx], ax
	popa
	ret


cmd11:	ret


;-------- CLS ---------------------------------------------------------------------------
cmd12:	pusha
	call cls
	popa
	ret
;----------------------------------------------------------------------------------------


;--------- comchat ----------------------------------------------------------------------
cmd13:	pusha
	mov si, ComChat_msg	;setup for displaying an info-message
	call cls		;clear screen
	call put_string		;display the message
	call Init_COM1		;initialize the com1 port

GetByte:
	call Get_COM1		;retrive a byte from COM1
	test ah, 1		;see if there was a byte retrived
	jz GetKey		;if not, see if user pressed something
	call put_char		;show the character on screen

GetKey:
	mov ah, 1		;see if there's a char in keyboard buffer
	int 0x16		;with BIOS
	jz GetByte		;if not, continue chat..
	xor ah, ah		;if so, use ordinary BIOS getkey interrupt and
	int 0x16		;fetch the key & fix keyboard buffer
	cmp al, 0x1B		;was it the ESC key?
	je ComChat_exit		;if so, get out of here..
	cmp al, 0x8		;was it a backspace?
	je ComChat_backspace	;if so, do a backspace the proper way
	cmp al, 0xD		;was it the Enter key?
	je ComChat_enterkey	;if so, make a new line the proper way
	call put_char		;otherwise show the character
	call Send_COM1		;and send it to the other part!
	jmp GetKey		;and start all over

ComChat_backspace:
	call put_char		;first go back (this only moves the cursor)
	call Send_COM1		;and tell it
	mov al, " "		;then write a space to get rid of the char
	call put_char
	call Send_COM1		;also make the other part do the same
	mov al, 0x8		;then backspace 1 step again
	call put_char
	call Send_COM1		;make the other machine do the same
	jmp GetKey		;and back to mainloop

ComChat_enterkey:
	call put_char		;al is 0xD = Enter, move the cursor one line down
	call Send_COM1		;and tell the other machine to do the same
	mov al, 10		;the move the cursor to the beginning of line
	call put_char
	call Send_COM1		;also make sure the other machine does the same
	jmp GetKey		;and back to mainloop

ComChat_exit:
	popa			;quick and dirty exit
	ret			;but it works..

ComChat_msg	db 13,10,
		db "Chat trough COM1 port - this rocks!",13,10,
		db "Just type and the other machine will see it in realtime..",13,10,
		db "Dont type at the same time, because that looks ugly-",13,10,
		db "not that it will crash or anything.. JonOS CANNOT crash!",13,10,
		db "ESC for exit -- have fun! :)",13,10,
		db "----------------------------------------------------------",13,10,
		db 13,10,0
;----------------------------------------------------------------------------------------



cmd14:
	ret
cmd15:
	ret
cmd16:
	ret
cmd17:
	ret
cmd18:
	ret
cmd19:
	ret
cmd20:
	ret
cmd21:
	ret


;----- Set color ------------------------------------------------------------------------
cmd22:	pusha
	mov si, msgSetNumberColor
	call put_string
	mov si, colorList
	call put_string

get_number_color:
	call getch

;check if user presses key in range 0-9, A-F, a-f
	cmp al, 0x30
	jb get_number_color
	cmp al, 0x39
	jbe set_number_color
	jmp get_number_color

set_number_color:
	mov [NumberColor], al

	mov si, msgSetTextColor
	call put_string
	mov si, colorList
	call put_string

get_text_color:
	call getch

;check if user presses key in range 0-9, A-F, a-f
	cmp al, 0x30
	jb get_text_color
	cmp al, 0x39
	jbe set_text_color
	jmp get_text_color

set_text_color:
	mov [TextColor], al
	popa
	ret

msgSetTextColor
	db 13,10,
	db "Choose a text color:",13,10,0

msgSetNumberColor
	db 13,10,
	db "Choose a number color:",13,10,0

colorList
	db "0 = BLACK      1 = BLUE          2 = GREEN        3 = CYAN",13,10,
	db "4 = RED        5 = MAGENTA       6 = BROWN        7 = LIGHTGREY",13,10,
	db "8 = DARKGREY   9 = LIGHTBLUE",13,10,0

;----------------------------------------------------------------------------------------

;------ Set video mode ------------------------------------------------------------------
cmd23:	pusha
	push cs
	pop es
	mov si, msgVideoModes
	call put_string
get_video_mode:
	call getch
	cmp al, 0x30
	jb get_video_mode
	cmp al, 0x35
	ja get_video_mode
	sub al, 0x30

	xor ah, ah
	mov si, ax
	mov bx, videoModes
	mov al, [bx+si]
	mov [VideoMode], al
	call set_video_mode
	popa
	ret


msgVideoModes
	db 13,10,
	db "Change video mode to:",13,10,
	db "0 - 40x25 B/W text",13,10,
	db "1 - 40x25 16 color text",13,10,
	db "2 - 80x25 Monochrome text",13,10,
	db "3 - 640x350 16 color graphics",13,10,
	db "4 - 640x480 16 color graphics",13,10,
	db "5 - 320x200 256 color graphics",13,10,
	db 0

videoModes	db 0x0, 0x1, 0x7, 0x10, 0x12, 0x13
;----------------------------------------------------------------------------------------
